(*
    EXMPL01.PAS - Example program for the TGX unit
    Copyright (c) 1993-2003,2004 by Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
program Tutor01;
uses Crt, Tgx;

procedure Abort( Msg: string );
begin
  TextMode( CO80 );
  WriteLn( Msg );
  Halt( 1 );
end;

const
  CharList : string[2] = #$C0#$00;      (* Char list *)
var
  P: PTgxWindow;
  I: word;

begin
  (* Initialize the library *)
  TextMode( CO80 );
  if( tgxInit <> 0 ) then
    Abort( 'Cannot initialize TGX library.' );

  (* Create a window *)
  P := tgxCreate( 0, 0,         (* Position *)
                  6, 3,         (* Size *)
                  LightGreen,   (* Attribute *)
                  @CharList[1]  (* Character list *)
                );
  if( P = NIL ) then
    Abort( 'Cannot allocate memory.' );
  tgxClear( P );                (* Clear the window *)
  tgxRefresh( P );              (* Make changes effective *)
  tgxShow( P, 0 );              (* Show window *)

  (* Write a number of random points *)
  GotoXY( 8, 1 );
  Write( 'This program runs in text mode...' );
  Randomize;
  for I:=1 to 200 do begin
    tgxSetPixel( P, Random(P^.PixelWidth), Random(P^.PixelHeight) );
    tgxWaitRetrace;             (* Insert a delay *)
    tgxRefresh( P );            (* Show window *)
  end;

  (* Wait for a keypress *)
  Write( ' press any key to exit.' );
  I := byte(ReadKey);

  (* Destroy window *)
  ClrScr;
  tgxDestroy( P );

  (* Terminate the library and exit to DOS *)
  tgxDone;
end.
